
/* 
 * Copyright (c) 1993-2003 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef viman_TCLSERV_CLIENT_MSG_LIB_H
#define viman_TCLSERV_CLIENT_MSG_LIB_H

#include <server/vimanType.h>

/*---------------- PROTOTYPES DES FONCTIONS EXTERNES ------------------*/

#ifdef __cplusplus
extern "C" {
#endif

int vimanTclservClientInit (TCLSERV_CLIENT_ID pClientId);

int vimanTclservClientEnd (TCLSERV_CLIENT_ID clientId);



int vimanTclservClientInitRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 VimanInitStr *(in_initStruct) 
		);

int vimanTclservClientInitReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int vimanTclservClientInitRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				VimanInitStr *(in_initStruct) ,
				
				int *bilan);

int vimanTclservClientInitRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					VimanInitStr *(in_initStruct) ,
					
					int *bilan);




int vimanTclservClientSetTrackingUserModeRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 VimanBool *(in_flagUserTracking)
		);

int vimanTclservClientSetTrackingUserModeReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int vimanTclservClientSetTrackingUserModeRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 VimanBool *(in_flagUserTracking) ,
				 
				 int *bilan);




int vimanTclservClientActivateTrackingRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId //,
				  
		);

int vimanTclservClientActivateTrackingReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int vimanTclservClientActivateTrackingRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				 //,
				
				int *bilan);

int vimanTclservClientActivateTrackingRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					 //,
					
					int *bilan);




int vimanTclservClientSetCameraLeftPoseRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 VimanThetaMat *(in_CAMERA_LEFT_ROB_POSE) 
		);

int vimanTclservClientSetCameraLeftPoseReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int vimanTclservClientSetCameraLeftPoseRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				VimanThetaMat *(in_CAMERA_LEFT_ROB_POSE) ,
				
				int *bilan);

int vimanTclservClientSetCameraLeftPoseRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					VimanThetaMat *(in_CAMERA_LEFT_ROB_POSE) ,
					
					int *bilan);




int vimanTclservClientGetCameraLeftPoseRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId //,
				  
		);

int vimanTclservClientGetCameraLeftPoseReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      VimanThetaMat *(out_CAMERA_LEFT_ROB_POSE),
			      int *bilan);


int vimanTclservClientGetCameraLeftPoseRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				 //,
				VimanThetaMat *(out_CAMERA_LEFT_ROB_POSE),
				int *bilan);

int vimanTclservClientGetCameraLeftPoseRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					 //,
					VimanThetaMat *(out_CAMERA_LEFT_ROB_POSE),
					int *bilan);




int vimanTclservClientGetCameraRightPoseRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId //,
				  
		);

int vimanTclservClientGetCameraRightPoseReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      VimanThetaMat *(out_CAMERA_RIGHT_ROB_POSE),
			      int *bilan);


int vimanTclservClientGetCameraRightPoseRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				 //,
				VimanThetaMat *(out_CAMERA_RIGHT_ROB_POSE),
				int *bilan);

int vimanTclservClientGetCameraRightPoseRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					 //,
					VimanThetaMat *(out_CAMERA_RIGHT_ROB_POSE),
					int *bilan);




int vimanTclservClientSetImageFrameCorrectionRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 VimanCorrectionVec *(in_corImageFrame)
		);

int vimanTclservClientSetImageFrameCorrectionReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int vimanTclservClientSetImageFrameCorrectionRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 VimanCorrectionVec *(in_corImageFrame) ,
				 
				 int *bilan);




int vimanTclservClientSetRobotFrameCorrectionRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 VimanCorrectionVec *(in_corOriginFrame)
		);

int vimanTclservClientSetRobotFrameCorrectionReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int vimanTclservClientSetRobotFrameCorrectionRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 VimanCorrectionVec *(in_corOriginFrame) ,
				 
				 int *bilan);




int vimanTclservClientStopRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int vimanTclservClientStopReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int vimanTclservClientStopRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 
				 int *bilan);




int vimanTclservClientGetObjectPoseRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 VimanString *(in_objectName)
		);

int vimanTclservClientGetObjectPoseReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       VimanThetaMat *(out_thetaMat),
			       int *bilan);

int vimanTclservClientGetObjectPoseRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 VimanString *(in_objectName) ,
				 VimanThetaMat *(out_thetaMat),
				 int *bilan);




int vimanTclservClientSetExportObjectNameRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 VimanString *(in_objectNameToExport)
		);

int vimanTclservClientSetExportObjectNameReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int vimanTclservClientSetExportObjectNameRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 VimanString *(in_objectNameToExport) ,
				 
				 int *bilan);




int vimanTclservClientGetFullObjectPoseRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 VimanString *(in_objectName)
		);

int vimanTclservClientGetFullObjectPoseReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       VimanObjectPublic *(out_objectPublic),
			       int *bilan);

int vimanTclservClientGetFullObjectPoseRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 VimanString *(in_objectName) ,
				 VimanObjectPublic *(out_objectPublic),
				 int *bilan);




int vimanTclservClientSetThresholdARToolKitRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 int *(in_thresholdARToolKit) 
		);

int vimanTclservClientSetThresholdARToolKitReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int vimanTclservClientSetThresholdARToolKitRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				int *(in_thresholdARToolKit) ,
				
				int *bilan);

int vimanTclservClientSetThresholdARToolKitRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					int *(in_thresholdARToolKit) ,
					
					int *bilan);


#ifdef __cplusplus
}
#endif
#endif /* vimanTCLSERV_CLIENT_MSG_LIB_H */

